

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.68. tokenize &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.3.69. tokenizer_list" href="tokenizer_list.html" />
    <link rel="prev" title="7.3.67. thread_limit" href="thread_limit.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/commands/tokenize.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="tokenizer_list.html" title="7.3.69. tokenizer_list"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="thread_limit.html" title="7.3.67. thread_limit"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>コマンド</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.68. </span><code class="docutils literal notranslate"><span class="pre">tokenize</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="tokenize">
<h1><span class="section-number">7.3.68. </span><code class="docutils literal notranslate"><span class="pre">tokenize</span></code><a class="headerlink" href="#tokenize" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.68.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">tokenize</span></code> コマンドは指定したトークナイザーでテキストをトークナイズします。これはトークナイズ処理のデバッグに便利です。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.68.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このコマンドにはたくさんの引数があります。</p>
<p><code class="docutils literal notranslate"><span class="pre">tokenizer</span></code> と <code class="docutils literal notranslate"><span class="pre">string</span></code> が必須の引数で、他の引数はすべて省略できます:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize tokenizer
         string
         [normalizer=null]
         [flags=NONE]
         [mode=ADD]
         [token_filters=NONE]
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.68.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>以下は簡単な使用例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Fulltext Search&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Fu&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ul&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ll&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lt&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;te&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ex&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;xt&quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t &quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; S&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Se&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ea&quot;
#     },
#     {
#       &quot;position&quot;: 11,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ar&quot;
#     },
#     {
#       &quot;position&quot;: 12,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rc&quot;
#     },
#     {
#       &quot;position&quot;: 13,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ch&quot;
#     },
#     {
#       &quot;position&quot;: 14,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;h&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>この例では必須のパラメーターだけ使っています。 <code class="docutils literal notranslate"><span class="pre">tokenizer</span></code> には <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> を、 <code class="docutils literal notranslate"><span class="pre">string</span></code> には <code class="docutils literal notranslate"><span class="pre">&quot;Fulltext</span> <span class="pre">Search&quot;</span></code> を指定しています。この例は <code class="docutils literal notranslate"><span class="pre">TokenBigram</span></code> トークナイザーで <code class="docutils literal notranslate"><span class="pre">&quot;Fulltext</span> <span class="pre">Search&quot;</span></code> をトークナイズしたトークンを返します。この例では <code class="docutils literal notranslate"><span class="pre">&quot;Fulltext</span> <span class="pre">Search&quot;</span></code> を正規化していません。</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.68.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このセクションではすべての引数について説明します。引数はカテゴリわけしています。</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.3.68.4.1. </span>必須引数<a class="headerlink" href="#required-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>必須引数は二つあります。 <code class="docutils literal notranslate"><span class="pre">tokenizer</span></code> と <code class="docutils literal notranslate"><span class="pre">string</span></code> です。</p>
<div class="section" id="tokenizer">
<span id="tokenize-tokenizer"></span><h4><span class="section-number">7.3.68.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">tokenizer</span></code><a class="headerlink" href="#tokenizer" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>トークナイザー名を指定します。 <code class="docutils literal notranslate"><span class="pre">tokenize</span></code> コマンドは <code class="docutils literal notranslate"><span class="pre">tokenizer</span></code> で指定された名前のトークナイザーを使います。</p>
<p>組み込みのトークナイザーについては <a class="reference internal" href="../tokenizers.html"><span class="doc">トークナイザー</span></a> を参照してください。</p>
<p>以下は組み込みの <code class="docutils literal notranslate"><span class="pre">TokenTrigram</span></code> トークナイザーを使う例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenTrigram &quot;Fulltext Search&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Ful&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ull&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;llt&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lte&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;tex&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ext&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;xt &quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t S&quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; Se&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Sea&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ear&quot;
#     },
#     {
#       &quot;position&quot;: 11,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;arc&quot;
#     },
#     {
#       &quot;position&quot;: 12,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rch&quot;
#     },
#     {
#       &quot;position&quot;: 13,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ch&quot;
#     },
#     {
#       &quot;position&quot;: 14,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;h&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>他のトークナイザーを使いたい場合は、 <a class="reference internal" href="register.html"><span class="doc">register</span></a> コマンドでトークナイザープラグインを登録する必要があります。例えば、 <a class="reference external" href="http://www.phontron.com/kytea/">KyTea</a> ベースのトークナイザーを <code class="docutils literal notranslate"><span class="pre">tokenizers/kytea</span></code> を登録することで使えます。</p>
</div>
<div class="section" id="string">
<span id="tokenize-string"></span><h4><span class="section-number">7.3.68.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">string</span></code><a class="headerlink" href="#string" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>トークナイズしたい文字列を指定します。</p>
<p><code class="docutils literal notranslate"><span class="pre">string</span></code> の中に文字列を含める場合は、シングルクォート（ <code class="docutils literal notranslate"><span class="pre">'</span></code> ）またはダブルクォート（ <code class="docutils literal notranslate"><span class="pre">&quot;</span></code> ）で <code class="docutils literal notranslate"><span class="pre">string</span></code> をクォートする必要があります。</p>
<p><code class="docutils literal notranslate"><span class="pre">string</span></code> の中で空白を使う例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Groonga is a fast fulltext earch engine!&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Gr&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ro&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;oo&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;on&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ng&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ga&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;a &quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; i&quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;is&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;s &quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; a&quot;
#     },
#     {
#       &quot;position&quot;: 11,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;a &quot;
#     },
#     {
#       &quot;position&quot;: 12,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; f&quot;
#     },
#     {
#       &quot;position&quot;: 13,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;fa&quot;
#     },
#     {
#       &quot;position&quot;: 14,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;as&quot;
#     },
#     {
#       &quot;position&quot;: 15,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;st&quot;
#     },
#     {
#       &quot;position&quot;: 16,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t &quot;
#     },
#     {
#       &quot;position&quot;: 17,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; f&quot;
#     },
#     {
#       &quot;position&quot;: 18,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;fu&quot;
#     },
#     {
#       &quot;position&quot;: 19,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ul&quot;
#     },
#     {
#       &quot;position&quot;: 20,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ll&quot;
#     },
#     {
#       &quot;position&quot;: 21,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lt&quot;
#     },
#     {
#       &quot;position&quot;: 22,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;te&quot;
#     },
#     {
#       &quot;position&quot;: 23,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ex&quot;
#     },
#     {
#       &quot;position&quot;: 24,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;xt&quot;
#     },
#     {
#       &quot;position&quot;: 25,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t &quot;
#     },
#     {
#       &quot;position&quot;: 26,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; e&quot;
#     },
#     {
#       &quot;position&quot;: 27,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ea&quot;
#     },
#     {
#       &quot;position&quot;: 28,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ar&quot;
#     },
#     {
#       &quot;position&quot;: 29,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rc&quot;
#     },
#     {
#       &quot;position&quot;: 30,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ch&quot;
#     },
#     {
#       &quot;position&quot;: 31,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;h &quot;
#     },
#     {
#       &quot;position&quot;: 32,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; e&quot;
#     },
#     {
#       &quot;position&quot;: 33,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;en&quot;
#     },
#     {
#       &quot;position&quot;: 34,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ng&quot;
#     },
#     {
#       &quot;position&quot;: 35,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;gi&quot;
#     },
#     {
#       &quot;position&quot;: 36,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;in&quot;
#     },
#     {
#       &quot;position&quot;: 37,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ne&quot;
#     },
#     {
#       &quot;position&quot;: 38,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;e!&quot;
#     },
#     {
#       &quot;position&quot;: 39,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;!&quot;
#     }
#   ]
# ]
</pre></div>
</div>
</div>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.3.68.4.2. </span>省略可能引数<a class="headerlink" href="#optional-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>いくつか省略可能な引数があります。</p>
<div class="section" id="normalizer">
<span id="tokenize-normalizer"></span><h4><span class="section-number">7.3.68.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">normalizer</span></code><a class="headerlink" href="#normalizer" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>ノーマライザー名を指定します。 <code class="docutils literal notranslate"><span class="pre">tokenize</span></code> コマンドは <code class="docutils literal notranslate"><span class="pre">normalizer</span></code> という名前のノーマライザーを使います。ノーマライザーは <code class="docutils literal notranslate"><span class="pre">TokenBigrma</span></code> など、N-gram関連のトークナイザーにとってとても重要です。</p>
<p>ノーマライザーはノーマライズ中にそれぞれの文字の種類を検出します。N-gram系のトークナイザーはトークナイズ中に文字の種類を利用します。</p>
<p>以下はノーマライザーを使わない例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Fulltext Search&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Fu&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ul&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ll&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lt&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;te&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ex&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;xt&quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t &quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; S&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Se&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ea&quot;
#     },
#     {
#       &quot;position&quot;: 11,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ar&quot;
#     },
#     {
#       &quot;position&quot;: 12,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rc&quot;
#     },
#     {
#       &quot;position&quot;: 13,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ch&quot;
#     },
#     {
#       &quot;position&quot;: 14,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;h&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>すべてのアルファベットが2文字ごとトークナイズされています。例えば、 <code class="docutils literal notranslate"><span class="pre">Fu</span></code> で1つのトークンになっています。</p>
<p>以下はノーマライザーを使う例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Fulltext Search&quot; NormalizerAuto
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;fulltext&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;search&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>連続するアルファベットが1つのトークンにトークナイズされています。例えば、 <code class="docutils literal notranslate"><span class="pre">fulltext</span></code> で1つのトークンになっています。</p>
<p>ノーマライザーを使いながら2文字でトークナイズしたい場合は <code class="docutils literal notranslate"><span class="pre">TokenBigramSplitSymbolAlpha</span></code> を使って下さい。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigramSplitSymbolAlpha &quot;Fulltext Search&quot; NormalizerAuto
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;fu&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ul&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ll&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lt&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;te&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ex&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;xt&quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t&quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;se&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ea&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ar&quot;
#     },
#     {
#       &quot;position&quot;: 11,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rc&quot;
#     },
#     {
#       &quot;position&quot;: 12,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ch&quot;
#     },
#     {
#       &quot;position&quot;: 13,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;h&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>すべてのアルファベットが2文字ごとにトークナイズされています。そして、すべての文字が小文字にノーマライズされています。例えば、 <code class="docutils literal notranslate"><span class="pre">fu</span></code> で1つのトークンになっています。</p>
</div>
<div class="section" id="flags">
<span id="tokenize-flags"></span><h4><span class="section-number">7.3.68.4.2.2. </span><code class="docutils literal notranslate"><span class="pre">flags</span></code><a class="headerlink" href="#flags" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>トークナイズ処理をカスタマイズするオプションを指定します。「 <code class="docutils literal notranslate"><span class="pre">|</span></code> 」で区切って複数のオプションを指定することができます。例えば、 <code class="docutils literal notranslate"><span class="pre">NONE|ENABLE_TOKENIZED_DELIMITER</span></code> というように指定できます。</p>
<p>指定可能なフラグは以下の通りです。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 50%" />
<col style="width: 50%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>フラグ</p></th>
<th class="head"><p>説明</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">NONE</span></code></p></td>
<td><p>無視されます。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">ENABLE_TOKENIZED_DELIMITER</span></code></p></td>
<td><p>トークナイズ済み区切り文字を有効にします。トークナイズ済み区切り文字の詳細は <a class="reference internal" href="../tokenizers.html"><span class="doc">トークナイザー</span></a> を参照してください。</p></td>
</tr>
</tbody>
</table>
<p>以下は <code class="docutils literal notranslate"><span class="pre">ENABLE_TOKENIZED_DELIMITER</span></code> を使った例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenDelimit &quot;Full￾text Sea￾crch&quot; NormalizerAuto ENABLE_TOKENIZED_DELIMITER
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;full&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;text sea&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;crch&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">TokenDelimit</span></code> トークナイザーはトークナイズ済み区切り文字をサポートしているトークナイザーの1つです。 <code class="docutils literal notranslate"><span class="pre">ENABLE_TOKENIZED_DELIMITER</span></code> でトークナイズ済み区切り文字を有効に出来ます。トークナイズ済み区切り文字はトークンの区切りを表す特別な文字です。この文字は <code class="docutils literal notranslate"><span class="pre">U+FFFE</span></code> です。この文字コードはどの文字にも割り当てられていません。つまり、通常の文字列にはこの文字は現れません。よって、トークンの区切りを表すという目的には適切な文字です。 <code class="docutils literal notranslate"><span class="pre">ENABLE_TOKENIZED_DELIMITER</span></code> が有効のときは、対象文字列はすでにトークナイズ済みであると扱われます。トークナイザーは単にトークナイズ済み区切り文字で区切ってトークナイズします。</p>
</div>
<div class="section" id="mode">
<span id="tokenize-mode"></span><h4><span class="section-number">7.3.68.4.2.3. </span><code class="docutils literal notranslate"><span class="pre">mode</span></code><a class="headerlink" href="#mode" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>トークナイズモードを指定します。 <code class="docutils literal notranslate"><span class="pre">ADD</span></code> を指定すると、ドキュメント追加時と同じルールでトークナイズされます。 <code class="docutils literal notranslate"><span class="pre">GET</span></code> を指定すると、ドキュメント検索時と同じルールでトークナイズされます。省略された場合、 <code class="docutils literal notranslate"><span class="pre">ADD</span></code> モードでトークナイズされます。</p>
<p>デフォルトのモードは <code class="docutils literal notranslate"><span class="pre">ADD</span></code> です。</p>
<p>以下は <code class="docutils literal notranslate"><span class="pre">ADD</span></code> モードの例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Fulltext Search&quot; --mode ADD
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Fu&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ul&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ll&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lt&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;te&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ex&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;xt&quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t &quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; S&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Se&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ea&quot;
#     },
#     {
#       &quot;position&quot;: 11,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ar&quot;
#     },
#     {
#       &quot;position&quot;: 12,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rc&quot;
#     },
#     {
#       &quot;position&quot;: 13,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ch&quot;
#     },
#     {
#       &quot;position&quot;: 14,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;h&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>最後のアルファベットは1文字でトークナイズされています。</p>
<p>以下は <code class="docutils literal notranslate"><span class="pre">GET</span></code> モードの例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenBigram &quot;Fulltext Search&quot; --mode GET
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Fu&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ul&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ll&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;lt&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;te&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ex&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;xt&quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t &quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot; S&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;Se&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ea&quot;
#     },
#     {
#       &quot;position&quot;: 11,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ar&quot;
#     },
#     {
#       &quot;position&quot;: 12,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;rc&quot;
#     },
#     {
#       &quot;position&quot;: 13,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ch&quot;
#     }
#   ]
# ]
</pre></div>
</div>
<p>最後のアルファベットは2文字でトークナイズされています。</p>
</div>
<div class="section" id="token-filters">
<span id="tokenize-token-filters"></span><h4><span class="section-number">7.3.68.4.2.4. </span><code class="docutils literal notranslate"><span class="pre">token_filters</span></code><a class="headerlink" href="#token-filters" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>トークンフィルターを指定します。 <code class="docutils literal notranslate"><span class="pre">tokenize</span></code> コマンドは <code class="docutils literal notranslate"><span class="pre">token_filters</span></code> という名前のトークンフィルターを使います。</p>
<p>トークンフィルターについては <a class="reference internal" href="../token_filters.html"><span class="doc">トークンフィルター</span></a> を参照してください。</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<span id="tokenize-return-value"></span><h2><span class="section-number">7.3.68.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">tokenize</span></code> コマンドはトークナイズしたトークンをすべて返します。各トークンはトークン自身の文字列情報以外にいくつかの属性を持ちます。属性は今後増えていく可能性があります:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, tokens]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">HEADER</span></code></p>
<blockquote>
<div><p><code class="docutils literal notranslate"><span class="pre">HEADER</span></code> については <a class="reference internal" href="../command/output_format.html"><span class="doc">出力形式</span></a> を参照してください。</p>
</div></blockquote>
<p><code class="docutils literal notranslate"><span class="pre">tokens</span></code></p>
<blockquote>
<div><p><code class="docutils literal notranslate"><span class="pre">tokens</span></code> はトークンの配列です。トークンは以下の属性を持ったオブジェクトです。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 50%" />
<col style="width: 50%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>名前</p></th>
<th class="head"><p>説明</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">value</span></code></p></td>
<td><p>トークン自身</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">position</span></code></p></td>
<td><p>N番目のトークン。</p></td>
</tr>
</tbody>
</table>
</div></blockquote>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.3.68.6. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../tokenizers.html"><span class="doc">トークナイザー</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.68. <code class="docutils literal notranslate"><span class="pre">tokenize</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.68.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.3.68.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.3.68.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.3.68.4. 引数</a><ul>
<li><a class="reference internal" href="#required-parameters">7.3.68.4.1. 必須引数</a><ul>
<li><a class="reference internal" href="#tokenizer">7.3.68.4.1.1. <code class="docutils literal notranslate"><span class="pre">tokenizer</span></code></a></li>
<li><a class="reference internal" href="#string">7.3.68.4.1.2. <code class="docutils literal notranslate"><span class="pre">string</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.3.68.4.2. 省略可能引数</a><ul>
<li><a class="reference internal" href="#normalizer">7.3.68.4.2.1. <code class="docutils literal notranslate"><span class="pre">normalizer</span></code></a></li>
<li><a class="reference internal" href="#flags">7.3.68.4.2.2. <code class="docutils literal notranslate"><span class="pre">flags</span></code></a></li>
<li><a class="reference internal" href="#mode">7.3.68.4.2.3. <code class="docutils literal notranslate"><span class="pre">mode</span></code></a></li>
<li><a class="reference internal" href="#token-filters">7.3.68.4.2.4. <code class="docutils literal notranslate"><span class="pre">token_filters</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.68.5. 戻り値</a></li>
<li><a class="reference internal" href="#see-also">7.3.68.6. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="thread_limit.html"
                        title="前の章へ"><span class="section-number">7.3.67. </span><code class="docutils literal notranslate"><span class="pre">thread_limit</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="tokenizer_list.html"
                        title="次の章へ"><span class="section-number">7.3.69. </span><code class="docutils literal notranslate"><span class="pre">tokenizer_list</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="tokenizer_list.html" title="7.3.69. tokenizer_list"
             >次へ</a> |</li>
        <li class="right" >
          <a href="thread_limit.html" title="7.3.67. thread_limit"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>コマンド</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.68. </span><code class="docutils literal notranslate"><span class="pre">tokenize</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>